﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ThinkGeo.MapSuite.MvcEdition;
using ThinkGeo.MapSuite.Core;

namespace MvcMapNullException.Controllers
{
    public class MapNullController : Controller
    {
        //
        // GET: /MapNull/

        public ActionResult Index()
        {
            return View();
        }

        [MapActionFilter]
        public string GetNewCoordinate(Map map, GeoCollection<object> args)
        {
            //var markerLayer = map.CustomOverlays["AnimationMarker"] as SimpleMarkerOverlay;
            //var marker = markerLayer.Markers[0];
            //var position = marker.Position;

            var markerOverlay = map.CustomOverlays["AnimationMarker"] as LayerOverlay;
            var layer = markerOverlay.Layers[0] as InMemoryFeatureLayer;


            var position = layer.InternalFeatures[0].GetShape() as PointShape;

            Random random = new Random(DateTime.Now.Millisecond);

            double randomeDb1 = random.NextDouble();
            var x = position.X + (randomeDb1 > 0.5 ? randomeDb1 * (-1) : randomeDb1);
            double randomeDb2 = random.NextDouble();
            var y = position.Y + (randomeDb2 > 0.5 ? randomeDb2 * (-1) : randomeDb2);

            Console.WriteLine(x + "," + y);
            //return string.Format("{0},{1}", x, y);

            layer.InternalFeatures.Clear();
            layer.InternalFeatures.Add(new Feature(x, y));

            return string.Empty;
        }
    }
}
